
# Prof. Arash E. Zaghi, Majid Cashany, @ UConn
#August 13,2013 ADRiK
#units kip, in,

#     /|                           forceBeamColumn
#     /| 1(6DOF)------------------------------------------------------3(6DOF)                   y
#     /|                                                              5(3DOF)                   |
#                                                                      |                        |
#                                                                      |zeroLengthImpact3D      ---> x
#                                                                      |
#     /|                                                              6(3DOF)
#     /| 2(6DOF)------------------------------------------------------4(6DOF)
#     /|                            forceBeamColumn

wipe all

model BasicBuilder -ndm 3 -ndf 6
node 1 0 0 0
node 2 0 0 0
node 3 100 0 0
node 4 100 0 0

###################################### generate nodes in 3DOF domain and tie them up with 6DOF nodes:
model BasicBuilder -ndm 3 -ndf 3
node 5 100 0 0
node 6 100 0 0
model BasicBuilder -ndm 3 -ndf 6
equalDOF 3 5 1 2 3
equalDOF 4 6 1 2 3
######################################

mass 3 1 1 1 0 0 0
mass 4 10 10 10 10 10 10

fix 1 1 1 1 1 1 1
fix 2 1 1 1 1 1 1

set E 29000.0; set A 75.6; set Iz 3400.0; set Iy 3400.0; set G 11153.846 ; set J 3400.0;
section Elastic 1 $E $A $Iz $Iy $G $J
geomTransf Linear 1 0 1 0
element forceBeamColumn 13  1 3   5 1 1
element forceBeamColumn 24  2 4   5 1 1

################################################## implementation of zeroLengthImpact3D with nodes in 3DOF domain:
set direction 2; # direction of normal of contact surface
set initGap 0.005; # initial gap
set frictionRatio 0.1; # friction ratio 
set Kt 1.0e5; # penalty stiffness for tangential directions 
set Kn 1.0e5; # penalty stiffness for normal direction 
set Kn2 [expr $Kn * 0.1]; # penalty stiffness after yielding, based on Hertz impact model 
set Delta_y 0.001; # yield displacement based on Hertz impact model  
set cohesion 0.0; # cohesion
element zeroLengthImpact3D 56 5 6 $direction $initGap $frictionRatio $Kt $Kn $Kn2 $Delta_y $cohesion;
##################################################

puts "model is built";

file mkdir output;
recorder Node -time -file output/dispX.out -node 1 2 3 4 5 6 -dof 1 disp
recorder Node -time -file output/dispY.out -node 1 2 3 4 5 6 -dof 2 disp
recorder Node -time -file output/dispZ.out -node 1 2 3 4 5 6 -dof 3 disp
recorder Element -time -file output/ele56.out -ele 56 globalForce

#recorder display $windowTitle $xLoc $yLoc $xPixels $yPixels <-file $fileName>
recorder display "animation" 10 10 800 800 -wipe;
prp 0 0 1
vup 0 1 0;#view-up vector (vup)
vpn 0 0 1;#view-plane normal (vpn)
viewWindow -60 60 -60 60
display 1 3 1;

set g 386
timeSeries Path 1 -fileTime input/t.txt -filePath input/x.txt -factor [expr $g]
timeSeries Path 2 -fileTime input/t.txt -filePath input/y.txt -factor [expr $g]
timeSeries Path 3 -fileTime input/t.txt -filePath input/z.txt -factor [expr $g]

#pattern UniformExcitation $patternTag $dir -accel $tsTag <-vel0 $ver0>
pattern UniformExcitation 1 1 -accel 1;
pattern UniformExcitation 2 2 -accel 2;
pattern UniformExcitation 3 3 -accel 3;

wipeAnalysis

test EnergyIncr 1.0e-4 1000 0
algorithm Broyden  
numberer RCM
constraints Transformation
system UmfPack -lvalueFact 10
#system SparseGeneral
#system BandGeneral
#integrator GeneralizedMidpoint 0.50
#integrator Newmark $gamma $beta
#integrator Newmark 0.5 0.25
#integrator HHT 0.6
#integrator TRBDF2
integrator Newmark 0.6 0.3025
#integrator Newmark 0.5 [expr 1.0/6.0]
#integrator HHT $alpha <$gamma $beta>
#integrator HHT 1.0
#integrator HHT 1.0 0.5 0.25
#set HHTalpha 1.0;
#integrator HHT $HHTalpha [expr 1.5-$HHTalpha] [expr pow((2-$HHTalpha),2)/4]
analysis Transient
#analyze $NPTS $DT;                                                                      # apply 1000 0.02-sec time steps in analysis

set DT .005
set timeStepReduction 10
set tCurrent [getTime]
set tFinal 47
set ok 0
puts ".. loop of solver ........................................................................ started .."
while {$ok == 0 && $tCurrent < $tFinal} {
algorithm KrylovNewton
set ok [analyze 1 [expr $DT]];                                     # actually perform analysis; returns ok=0 if analysis was successful
 
 
 
                                if {$ok != 0} {
                                        set ok [analyze 1 [expr $DT/10.0]];
                                        
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKKtimeStep/10.0"
                                }}
 
 
 
 
 
                                if {$ok != 0} {
                                        set ok [analyze 1 [expr $DT/$timeStepReduction]];
                                        
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKKtimeStep/$timeStepReduction"
                                }}
 
 
 
 
 
 
                                if {$ok != 0} {
                                                puts "Trying Broyden .."
                                                algorithm Broyden
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
 
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK44444"
                                }}
 
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying KrylovNewton .."
                                                algorithm KrylovNewton
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK33333"
                                }}
 
               
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying Newton -initial .."
                                                algorithm Newton -initial
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK33333"
                                }}
                               
 
                               
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying ModifiedNewton .."
                                                algorithm ModifiedNewton
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK55555"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying Newton .."
                                                algorithm Newton
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK66666"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying ModifiedNewton -initial .."
                                                algorithm ModifiedNewton -initial
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK77777"
                                }}
 
                                if {$ok != 0} {
 
                  puts "NG"
                                                puts "Trying BFGS .."
                                                algorithm BFGS
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK88888"
                                }}
                               
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying RCM .."
                                                numberer RCM
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
               
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying BandGeneral .."
                                                system BandGeneral
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying UmfPack .."
                                                system UmfPack
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying SparseGEN .."
                                                system SparseGEN
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying EnergyIncr 1.0e-4 40 .."
                                                test EnergyIncr 1.0e-4 40
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying NormUnbalance 1.0e-4 40 .."
                                                test NormUnbalance 1.0e-4 40
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
                                if {$ok != 0} {
                  puts "NG"
                                                puts "Trying RelativeNormDispIncr 1.0e-4 40 .."
                                                test RelativeNormDispIncr 1.0e-4 40
                  set ok [analyze 1 [expr $DT/$timeStepReduction]];                                           # actually perform analysis; returns ok=0 if analysis was successful
                                if {$ok == 0} {
            puts "OKKKKKKKKKKKKK99999"
                                }}
 
 
set tCurrent [getTime]
 
puts " Progress: [getTime] / $tFinal"

}

if {$ok != 0} {
                        puts "Simulation ran into a problem, solve it please!"
            }

if {$ok == 0} {
                        puts "Enjoy!"
            }